VAR
  byte out, s0, s1, s2, s3
  long duration
PUB Start(_out, dur, _s0, _s1, _s2, _s3, scale, sens)
  out := _out
  s0 := _s0
  s1 := _s1
  s2 := _s2
  s3 := _s3
  init_pins
  duration := dur
  set_state(scale, sens)
  dira[out] := 0                                             
       ctra := 0                                           
       ctra := (%01010 << 26 ) | (%111 << 23) | (0 << 9) | (out)  
       frqa := 1                                           
       phsa := 0
  return

PUB Set_State(scale, sens)
  case scale
    1: set_scale(0, 0)
    2: set_scale(1, 0)
    10: set_scale(0, 1)
    100: set_scale(1, 1)

  case sens
    0: set_sensitivity(0, 0)
    1: set_sensitivity(1, 0)
    10: set_sensitivity(0, 1) 
    100: set_sensitivity(1, 1)
    
PUB GetFreq : freq
       phsa := 0                                        
       pause(duration)                                     
       freq := phsa
    return

PRI Set_Scale(_s0, _s1)
  outa[s0] := _s0
  outa[s1] := _s1
  return

PRI Set_Sensitivity(_s2, _s3)
  outa[s2] := _s2
  outa[s3] := _s3
  return
  
PRI Init_Pins
  dira[s0] := 1
  outa[s0] := 0
  
  dira[s1] := 1
  outa[s1] := 0
  
  dira[s2] := 1
  outa[s2] := 0
  
  dira[s3] := 1
  outa[s3] := 0
  return

PRI Pause(ms)
  waitcnt(clkfreq / 1000 * ms + cnt)
  return 